// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * An electrical connection point (AC or DC) to a piece of conducting equipment. Terminals are
 * connected at physical connection points called connectivity nodes.
 * </pre>
 *
 * Protobuf type {@code commonmodule.ACDCTerminal}
 */
public final class ACDCTerminal extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.ACDCTerminal)
    ACDCTerminalOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ACDCTerminal.newBuilder() to construct.
  private ACDCTerminal(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ACDCTerminal() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ACDCTerminal();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACDCTerminal_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACDCTerminal_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.ACDCTerminal.class, openfmb.commonmodule.ACDCTerminal.Builder.class);
  }

  public static final int IDENTIFIEDOBJECT_FIELD_NUMBER = 1;
  private openfmb.commonmodule.IdentifiedObject identifiedObject_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the identifiedObject field is set.
   */
  @java.lang.Override
  public boolean hasIdentifiedObject() {
    return identifiedObject_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   * @return The identifiedObject.
   */
  @java.lang.Override
  public openfmb.commonmodule.IdentifiedObject getIdentifiedObject() {
    return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.IdentifiedObjectOrBuilder getIdentifiedObjectOrBuilder() {
    return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
  }

  public static final int CONNECTED_FIELD_NUMBER = 2;
  private com.google.protobuf.BoolValue connected_;
  /**
   * <pre>
   * The connected status is related to a bus-branch model and the topological node to terminal
   * relation.  True implies the terminal is connected to the related topological node and false implies
   * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
   * without having to change the connectivity described by the topological node to terminal relation. A
   * valid case is that conducting equipment can be connected in one end and open in the other. In
   * particular for an AC line segment, where the reactive line charging can be significant, this is a
   * relevant case.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue connected = 2;</code>
   * @return Whether the connected field is set.
   */
  @java.lang.Override
  public boolean hasConnected() {
    return connected_ != null;
  }
  /**
   * <pre>
   * The connected status is related to a bus-branch model and the topological node to terminal
   * relation.  True implies the terminal is connected to the related topological node and false implies
   * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
   * without having to change the connectivity described by the topological node to terminal relation. A
   * valid case is that conducting equipment can be connected in one end and open in the other. In
   * particular for an AC line segment, where the reactive line charging can be significant, this is a
   * relevant case.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue connected = 2;</code>
   * @return The connected.
   */
  @java.lang.Override
  public com.google.protobuf.BoolValue getConnected() {
    return connected_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : connected_;
  }
  /**
   * <pre>
   * The connected status is related to a bus-branch model and the topological node to terminal
   * relation.  True implies the terminal is connected to the related topological node and false implies
   * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
   * without having to change the connectivity described by the topological node to terminal relation. A
   * valid case is that conducting equipment can be connected in one end and open in the other. In
   * particular for an AC line segment, where the reactive line charging can be significant, this is a
   * relevant case.
   * </pre>
   *
   * <code>.google.protobuf.BoolValue connected = 2;</code>
   */
  @java.lang.Override
  public com.google.protobuf.BoolValueOrBuilder getConnectedOrBuilder() {
    return connected_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : connected_;
  }

  public static final int SEQUENCENUMBER_FIELD_NUMBER = 3;
  private com.google.protobuf.Int32Value sequenceNumber_;
  /**
   * <pre>
   * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
   * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
   * first terminal is the "starting point" for a two terminal branch.
   * </pre>
   *
   * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
   * @return Whether the sequenceNumber field is set.
   */
  @java.lang.Override
  public boolean hasSequenceNumber() {
    return sequenceNumber_ != null;
  }
  /**
   * <pre>
   * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
   * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
   * first terminal is the "starting point" for a two terminal branch.
   * </pre>
   *
   * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
   * @return The sequenceNumber.
   */
  @java.lang.Override
  public com.google.protobuf.Int32Value getSequenceNumber() {
    return sequenceNumber_ == null ? com.google.protobuf.Int32Value.getDefaultInstance() : sequenceNumber_;
  }
  /**
   * <pre>
   * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
   * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
   * first terminal is the "starting point" for a two terminal branch.
   * </pre>
   *
   * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
   */
  @java.lang.Override
  public com.google.protobuf.Int32ValueOrBuilder getSequenceNumberOrBuilder() {
    return sequenceNumber_ == null ? com.google.protobuf.Int32Value.getDefaultInstance() : sequenceNumber_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (identifiedObject_ != null) {
      output.writeMessage(1, getIdentifiedObject());
    }
    if (connected_ != null) {
      output.writeMessage(2, getConnected());
    }
    if (sequenceNumber_ != null) {
      output.writeMessage(3, getSequenceNumber());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (identifiedObject_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getIdentifiedObject());
    }
    if (connected_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getConnected());
    }
    if (sequenceNumber_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getSequenceNumber());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.ACDCTerminal)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.ACDCTerminal other = (openfmb.commonmodule.ACDCTerminal) obj;

    if (hasIdentifiedObject() != other.hasIdentifiedObject()) return false;
    if (hasIdentifiedObject()) {
      if (!getIdentifiedObject()
          .equals(other.getIdentifiedObject())) return false;
    }
    if (hasConnected() != other.hasConnected()) return false;
    if (hasConnected()) {
      if (!getConnected()
          .equals(other.getConnected())) return false;
    }
    if (hasSequenceNumber() != other.hasSequenceNumber()) return false;
    if (hasSequenceNumber()) {
      if (!getSequenceNumber()
          .equals(other.getSequenceNumber())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasIdentifiedObject()) {
      hash = (37 * hash) + IDENTIFIEDOBJECT_FIELD_NUMBER;
      hash = (53 * hash) + getIdentifiedObject().hashCode();
    }
    if (hasConnected()) {
      hash = (37 * hash) + CONNECTED_FIELD_NUMBER;
      hash = (53 * hash) + getConnected().hashCode();
    }
    if (hasSequenceNumber()) {
      hash = (37 * hash) + SEQUENCENUMBER_FIELD_NUMBER;
      hash = (53 * hash) + getSequenceNumber().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ACDCTerminal parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ACDCTerminal parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ACDCTerminal parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.ACDCTerminal prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * An electrical connection point (AC or DC) to a piece of conducting equipment. Terminals are
   * connected at physical connection points called connectivity nodes.
   * </pre>
   *
   * Protobuf type {@code commonmodule.ACDCTerminal}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.ACDCTerminal)
      openfmb.commonmodule.ACDCTerminalOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACDCTerminal_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACDCTerminal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.ACDCTerminal.class, openfmb.commonmodule.ACDCTerminal.Builder.class);
    }

    // Construct using openfmb.commonmodule.ACDCTerminal.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      identifiedObject_ = null;
      if (identifiedObjectBuilder_ != null) {
        identifiedObjectBuilder_.dispose();
        identifiedObjectBuilder_ = null;
      }
      connected_ = null;
      if (connectedBuilder_ != null) {
        connectedBuilder_.dispose();
        connectedBuilder_ = null;
      }
      sequenceNumber_ = null;
      if (sequenceNumberBuilder_ != null) {
        sequenceNumberBuilder_.dispose();
        sequenceNumberBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ACDCTerminal_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.ACDCTerminal getDefaultInstanceForType() {
      return openfmb.commonmodule.ACDCTerminal.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.ACDCTerminal build() {
      openfmb.commonmodule.ACDCTerminal result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.ACDCTerminal buildPartial() {
      openfmb.commonmodule.ACDCTerminal result = new openfmb.commonmodule.ACDCTerminal(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.ACDCTerminal result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.identifiedObject_ = identifiedObjectBuilder_ == null
            ? identifiedObject_
            : identifiedObjectBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.connected_ = connectedBuilder_ == null
            ? connected_
            : connectedBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.sequenceNumber_ = sequenceNumberBuilder_ == null
            ? sequenceNumber_
            : sequenceNumberBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.ACDCTerminal) {
        return mergeFrom((openfmb.commonmodule.ACDCTerminal)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.ACDCTerminal other) {
      if (other == openfmb.commonmodule.ACDCTerminal.getDefaultInstance()) return this;
      if (other.hasIdentifiedObject()) {
        mergeIdentifiedObject(other.getIdentifiedObject());
      }
      if (other.hasConnected()) {
        mergeConnected(other.getConnected());
      }
      if (other.hasSequenceNumber()) {
        mergeSequenceNumber(other.getSequenceNumber());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getIdentifiedObjectFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getConnectedFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getSequenceNumberFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.IdentifiedObject identifiedObject_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder> identifiedObjectBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the identifiedObject field is set.
     */
    public boolean hasIdentifiedObject() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     * @return The identifiedObject.
     */
    public openfmb.commonmodule.IdentifiedObject getIdentifiedObject() {
      if (identifiedObjectBuilder_ == null) {
        return identifiedObject_ == null ? openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
      } else {
        return identifiedObjectBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setIdentifiedObject(openfmb.commonmodule.IdentifiedObject value) {
      if (identifiedObjectBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        identifiedObject_ = value;
      } else {
        identifiedObjectBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setIdentifiedObject(
        openfmb.commonmodule.IdentifiedObject.Builder builderForValue) {
      if (identifiedObjectBuilder_ == null) {
        identifiedObject_ = builderForValue.build();
      } else {
        identifiedObjectBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeIdentifiedObject(openfmb.commonmodule.IdentifiedObject value) {
      if (identifiedObjectBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          identifiedObject_ != null &&
          identifiedObject_ != openfmb.commonmodule.IdentifiedObject.getDefaultInstance()) {
          getIdentifiedObjectBuilder().mergeFrom(value);
        } else {
          identifiedObject_ = value;
        }
      } else {
        identifiedObjectBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearIdentifiedObject() {
      bitField0_ = (bitField0_ & ~0x00000001);
      identifiedObject_ = null;
      if (identifiedObjectBuilder_ != null) {
        identifiedObjectBuilder_.dispose();
        identifiedObjectBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.IdentifiedObject.Builder getIdentifiedObjectBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getIdentifiedObjectFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.IdentifiedObjectOrBuilder getIdentifiedObjectOrBuilder() {
      if (identifiedObjectBuilder_ != null) {
        return identifiedObjectBuilder_.getMessageOrBuilder();
      } else {
        return identifiedObject_ == null ?
            openfmb.commonmodule.IdentifiedObject.getDefaultInstance() : identifiedObject_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.IdentifiedObject identifiedObject = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder> 
        getIdentifiedObjectFieldBuilder() {
      if (identifiedObjectBuilder_ == null) {
        identifiedObjectBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.IdentifiedObject, openfmb.commonmodule.IdentifiedObject.Builder, openfmb.commonmodule.IdentifiedObjectOrBuilder>(
                getIdentifiedObject(),
                getParentForChildren(),
                isClean());
        identifiedObject_ = null;
      }
      return identifiedObjectBuilder_;
    }

    private com.google.protobuf.BoolValue connected_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> connectedBuilder_;
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     * @return Whether the connected field is set.
     */
    public boolean hasConnected() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     * @return The connected.
     */
    public com.google.protobuf.BoolValue getConnected() {
      if (connectedBuilder_ == null) {
        return connected_ == null ? com.google.protobuf.BoolValue.getDefaultInstance() : connected_;
      } else {
        return connectedBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     */
    public Builder setConnected(com.google.protobuf.BoolValue value) {
      if (connectedBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        connected_ = value;
      } else {
        connectedBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     */
    public Builder setConnected(
        com.google.protobuf.BoolValue.Builder builderForValue) {
      if (connectedBuilder_ == null) {
        connected_ = builderForValue.build();
      } else {
        connectedBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     */
    public Builder mergeConnected(com.google.protobuf.BoolValue value) {
      if (connectedBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          connected_ != null &&
          connected_ != com.google.protobuf.BoolValue.getDefaultInstance()) {
          getConnectedBuilder().mergeFrom(value);
        } else {
          connected_ = value;
        }
      } else {
        connectedBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     */
    public Builder clearConnected() {
      bitField0_ = (bitField0_ & ~0x00000002);
      connected_ = null;
      if (connectedBuilder_ != null) {
        connectedBuilder_.dispose();
        connectedBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     */
    public com.google.protobuf.BoolValue.Builder getConnectedBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getConnectedFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     */
    public com.google.protobuf.BoolValueOrBuilder getConnectedOrBuilder() {
      if (connectedBuilder_ != null) {
        return connectedBuilder_.getMessageOrBuilder();
      } else {
        return connected_ == null ?
            com.google.protobuf.BoolValue.getDefaultInstance() : connected_;
      }
    }
    /**
     * <pre>
     * The connected status is related to a bus-branch model and the topological node to terminal
     * relation.  True implies the terminal is connected to the related topological node and false implies
     * it is not.  In a bus-branch model, the connected status is used to tell if equipment is disconnected
     * without having to change the connectivity described by the topological node to terminal relation. A
     * valid case is that conducting equipment can be connected in one end and open in the other. In
     * particular for an AC line segment, where the reactive line charging can be significant, this is a
     * relevant case.
     * </pre>
     *
     * <code>.google.protobuf.BoolValue connected = 2;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder> 
        getConnectedFieldBuilder() {
      if (connectedBuilder_ == null) {
        connectedBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.BoolValue, com.google.protobuf.BoolValue.Builder, com.google.protobuf.BoolValueOrBuilder>(
                getConnected(),
                getParentForChildren(),
                isClean());
        connected_ = null;
      }
      return connectedBuilder_;
    }

    private com.google.protobuf.Int32Value sequenceNumber_;
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.Int32Value, com.google.protobuf.Int32Value.Builder, com.google.protobuf.Int32ValueOrBuilder> sequenceNumberBuilder_;
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     * @return Whether the sequenceNumber field is set.
     */
    public boolean hasSequenceNumber() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     * @return The sequenceNumber.
     */
    public com.google.protobuf.Int32Value getSequenceNumber() {
      if (sequenceNumberBuilder_ == null) {
        return sequenceNumber_ == null ? com.google.protobuf.Int32Value.getDefaultInstance() : sequenceNumber_;
      } else {
        return sequenceNumberBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     */
    public Builder setSequenceNumber(com.google.protobuf.Int32Value value) {
      if (sequenceNumberBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        sequenceNumber_ = value;
      } else {
        sequenceNumberBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     */
    public Builder setSequenceNumber(
        com.google.protobuf.Int32Value.Builder builderForValue) {
      if (sequenceNumberBuilder_ == null) {
        sequenceNumber_ = builderForValue.build();
      } else {
        sequenceNumberBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     */
    public Builder mergeSequenceNumber(com.google.protobuf.Int32Value value) {
      if (sequenceNumberBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          sequenceNumber_ != null &&
          sequenceNumber_ != com.google.protobuf.Int32Value.getDefaultInstance()) {
          getSequenceNumberBuilder().mergeFrom(value);
        } else {
          sequenceNumber_ = value;
        }
      } else {
        sequenceNumberBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     */
    public Builder clearSequenceNumber() {
      bitField0_ = (bitField0_ & ~0x00000004);
      sequenceNumber_ = null;
      if (sequenceNumberBuilder_ != null) {
        sequenceNumberBuilder_.dispose();
        sequenceNumberBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     */
    public com.google.protobuf.Int32Value.Builder getSequenceNumberBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getSequenceNumberFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     */
    public com.google.protobuf.Int32ValueOrBuilder getSequenceNumberOrBuilder() {
      if (sequenceNumberBuilder_ != null) {
        return sequenceNumberBuilder_.getMessageOrBuilder();
      } else {
        return sequenceNumber_ == null ?
            com.google.protobuf.Int32Value.getDefaultInstance() : sequenceNumber_;
      }
    }
    /**
     * <pre>
     * The orientation of the terminal connections for a multiple terminal conducting equipment.  The
     * sequence numbering starts with 1 and additional terminals should follow in increasing order.   The
     * first terminal is the "starting point" for a two terminal branch.
     * </pre>
     *
     * <code>.google.protobuf.Int32Value sequenceNumber = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        com.google.protobuf.Int32Value, com.google.protobuf.Int32Value.Builder, com.google.protobuf.Int32ValueOrBuilder> 
        getSequenceNumberFieldBuilder() {
      if (sequenceNumberBuilder_ == null) {
        sequenceNumberBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            com.google.protobuf.Int32Value, com.google.protobuf.Int32Value.Builder, com.google.protobuf.Int32ValueOrBuilder>(
                getSequenceNumber(),
                getParentForChildren(),
                isClean());
        sequenceNumber_ = null;
      }
      return sequenceNumberBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.ACDCTerminal)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.ACDCTerminal)
  private static final openfmb.commonmodule.ACDCTerminal DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.ACDCTerminal();
  }

  public static openfmb.commonmodule.ACDCTerminal getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ACDCTerminal>
      PARSER = new com.google.protobuf.AbstractParser<ACDCTerminal>() {
    @java.lang.Override
    public ACDCTerminal parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ACDCTerminal> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ACDCTerminal> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.ACDCTerminal getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

